:- module updatedb.

:- interface.
:- import_module io.

:- pred main(io::di, io::uo) is det.


:- implementation.
:- import_module int, uint64, bool, list.
:- import_module odbc.

:- type amend == pred(pred(io, io), bool, odbc.state, odbc.state).
:- inst amend == (pred(out(pred(di, uo) is det), out, di, uo) is det).


:- pred amend(
    list(amend)::in(list(amend)),
    list(amend)::in(list(amend)),
    pred(io, io)::out(pred(di, uo) is det),
    odbc.state::di,
    odbc.state::uo
) is det.

amend(_, [], (pred(IO::di, IO::uo) is det :- true), !DB).

amend(All, [Amend|Amends], AmendIO, !DB) :-
    Amend(AmendIO0, Done, !DB),
    (
        Done = yes,
        AmendIO = AmendIO0
    ;
        Done = no,
        amend(All, Amends, AmendIO, !DB)
    ).


main(!IO) :-
    true.
